import java.util.ArrayList;
import java.io.*;
import java.util.Iterator;
// </editor-fold> 
public class Partida {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D30E763C-6608-F4D5-0020-0034E069E633]
    // </editor-fold> 
    private ArrayList<Jugador> mJugador = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.58569FCC-E200-8566-B8F4-885D14AC349B]
    // </editor-fold> 
    private Tablero mTablero = new Tablero ();
    
    private int turno;
    private int numeroJugadores;
    private boolean tropascolocadas=false; // para controlar la secuencia de acciones dentro del turno
    
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C3EBB95A-F303-A503-5B6A-94E0EA93F13E]
    // </editor-fold> 
    public Partida () {
        this.mJugador.add(new Jugador(1,"Alba"));//0
        this.mJugador.add(new Jugador(2,"MRosario"));//1
        this.mJugador.add(new Jugador(3,"JuanJose"));//2
        this.mJugador.add(new Jugador(4,"CPU"));//3
        this.numeroJugadores=mJugador.size();
        this.turno = 1;
        // vamos a inicializar los territorios que tienen cada jugador
        this.mJugador.get(0).poseeTerritorio(this.mTablero.getTerritorio().get(2));
        this.mJugador.get(1).poseeTerritorio(this.mTablero.getTerritorio().get(0));
        this.mJugador.get(2).poseeTerritorio(this.mTablero.getTerritorio().get(1));
        this.mJugador.get(3).poseeTerritorio(this.mTablero.getTerritorio().get(3));
        this.mJugador.get(3).poseeTerritorio(this.mTablero.getTerritorio().get(4));
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.EF378225-797C-08A0-8EFC-A7F52A40A485]
    // </editor-fold> 
    public ArrayList<Jugador> getJugador () {
        return null;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D7D43669-88B9-D964-3912-26D7ED9D1E76]
    // </editor-fold> 
    public void setJugador (ArrayList<Jugador> val) {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7F456AC5-0C3B-7F11-C393-E7222DBAC0FB]
    // </editor-fold> 
    public Tablero getTablero () {
        return null;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.5BFA2477-06F2-7AEC-826E-28D327F0F5AC]
    // </editor-fold> 
    public void setTablero (Tablero val) {
    }

    public void jugarPartida () {
        System.out.println ("*** INICIO DEL JUEGO ***");
        int numjug;
        int num = 0;
        
        while (true) {
            numjug = this.turno-1; // aqui guardaremos la posicion del Array segun el turno
            String nombre = mJugador.get(numjug).getNombre();
            System.out.println ("--------");
            System.out.println ("TURNO DE: "+nombre);
            System.out.println ("--------");
            if (!this.tropascolocadas) System.out.println ("1. Colocar ejercitos ("+mJugador.get(numjug).getEjercitosdisponibles()+" pendientes de colocar)");
            if (this.tropascolocadas) System.out.println ("2. Atacar");
            if (this.tropascolocadas) System.out.println ("3. Distribuir tropas");
            System.out.println ("4. Ver/cambiar cartas");
            System.out.println ("5. Finalizar turno");
            System.out.println ("6. Menu");
            System.out.println ("--------");
            System.out.print ("Elija opcion: ");
            // Leer opcion
            BufferedReader br = new BufferedReader(new InputStreamReader(System.in), 1);
            try { num = Integer.parseInt(br.readLine()); }
            catch (IOException ex) { System.out.println(ex); }
            
            switch (num) {
                case 1: this.colocarEjercito(mJugador.get(numjug)); break;
                case 2: this.atacar(mJugador.get(numjug)); break;
                case 3: this.moverEjercito(mJugador.get(numjug)); break;
                case 4: this.verCartas(mJugador.get(numjug)); break;
                case 5: this.finalizarTurno(mJugador.get(numjug)); 
                        mJugador.get(numjug).addEjercitosdisponibles(3);
                        break;
                case 6: this.menu (); break;
            }
            
        }
    }
    
    public void colocarEjercito (Jugador jug) {
        if (!this.tropascolocadas) {
            System.out.println ("Ejercitos colocados.");
            this.tropascolocadas=true;
        } else {
            System.out.println ("No puedes volver a colocar los ejercitos");
        }
    }
    
    public void atacar (Jugador jug) {
        if (this.tropascolocadas) {
            System.out.println ("OPCION ATACAR");
            System.out.println ("Lista de tus paises");
            // recorremos los paises que posee y los muestra para elegir
            Iterator it = jug.getTerritorio().iterator();
            while (it.hasNext()) {
                Territorio t=(Territorio)it.next();
                System.out.println ("ID: "+t.getId()+" - "+t.getNombre()+" ("+t.getEjercitos()+" ejercitos)");
            }
            // Leer opcion
            int origen=0;
            System.out.println ("Introduce el id del pais de origen");
            BufferedReader br = new BufferedReader(new InputStreamReader(System.in), 1);
            try { origen = Integer.parseInt(br.readLine()); }
            catch (IOException ex) { System.out.println(ex); }
            Territorio tOrigen = mTablero.getTerritorioId(origen);
            // comprobamos si puede atacar con un pais con id=num
            if (jug.puedeAtacar(origen)) {             
                System.out.println ("Lista de paises vecinos a los que puede atacar");
                // recorremos los paises vecinos
                it = tOrigen.getVecinos().iterator();
                while (it.hasNext()) {
                    Territorio t=(Territorio)it.next();
                    Iterator it2 = jug.getTerritorio().iterator();
                    Boolean b = false;
                    while (it2.hasNext() && !b) {
                        Territorio t2=(Territorio)it2.next();
                        if (t2.getId()==t.getId()) b=true;
                    }
                    if (!b) System.out.println ("ID: "+t.getId()+" - "+t.getNombre()+" ("+t.getEjercitos()+" ejercitos)");
                    
                }
                // Leer opcion
                int destino=0;
                System.out.println ("Introduce el id del pais destino");
                br = new BufferedReader(new InputStreamReader(System.in), 1);
                try { destino = Integer.parseInt(br.readLine()); }
                catch (IOException ex) { System.out.println(ex); }
                // Comprobamos si tanto pais origen como destino son validos
                // es decir, que puede atacar a...
                if (jug.PuedeAtacarA(origen, destino)) {
                    int opcionContinuar = 1;
                    // se realizara este bucle hasta que el jugador desee salir o no se pueda seguir atacando
                    while (opcionContinuar==1 && jug.PuedeAtacarA(origen, destino)) {
                        // OBJETO PAIS ATACANTE
                        Territorio tAtacante = mTablero.getTerritorio(origen);
                        // OBJETO PAIS DEFENSOR
                        Territorio tDefensor = mTablero.getTerritorio(destino);
                        // Mostramos un mensaje de como se va a realizar el ataque...                    
                        int ejOrigen=tAtacante.getEjercitos();
                        int ejDestino=tDefensor.getEjercitos();                    
                        // TIRAR DADOS
                        // vamos a ver cuantos dados necesitamos
                        int dadosOrigen; int dadosDestino; // aqui guardamos los datos que vamos a usar tanto ataque como def.
                        if (tAtacante.getEjercitos()>3) dadosOrigen=3;
                        else dadosOrigen=ejOrigen-1;
                        if (tDefensor.getEjercitos()>2) dadosDestino=2;
                        else dadosDestino=ejDestino;
                        // mostramos el mensaje
                        System.out.println ("PAIS ATACANTE: "+tAtacante.getNombre()+" ("+tAtacante.getEjercitos()+" ejercitos)");
                        System.out.println ("PAIS DEFENSOR: "+tDefensor.getNombre()+" ("+tDefensor.getEjercitos()+" ejercitos)");
                        System.out.println ("Ataca con "+dadosOrigen+" dados y defiende con "+dadosDestino+" dados");
                        // Preguntamos si desea tirar o retirarse
                        System.out.println ("Elija su opcion");
                        System.out.println ("1. Tirar dados");
                        System.out.println ("2. Retirarse");
                        br = new BufferedReader(new InputStreamReader(System.in), 1);
                        try { opcionContinuar = Integer.parseInt(br.readLine()); }
                        catch (IOException ex) { System.out.println(ex); }
                        if (opcionContinuar==1) {
                            // TIRAR DADOS...
                            ArrayList <Dado> dadosAtaque = new ArrayList();
                            ArrayList <Dado> dadosDefensa = new ArrayList ();
                            for (int i=0;i<dadosOrigen;i++) {
                                Dado d = new Dado ();
                                d.tirar ();
                                dadosAtaque.add(d);
                                System.out.println ("Tirada ataque "+(i+1)+" : "+d.getTirada());
                            }
                            for (int i=0;i<dadosDestino;i++) {
                                Dado d = new Dado ();
                                d.tirar ();
                                dadosDefensa.add(d);
                                System.out.println ("Tirada defensa "+(i+1)+" : "+d.getTirada());
                            }
                            // ---------- fin tirar dados

                            // comparar dados y mostrar resultados
                            while (dadosAtaque.size()>0 && dadosDefensa.size()>0 ) {
                                // sacamos el dado mayor de ataque
                                int dadoMayorAtaque = 0;
                                int posA=0; // posicion en la lista del dado mayor de ataque para despues borrar
                                int i=0;
                                it = dadosAtaque.iterator();
                                while (it.hasNext()) {
                                    Dado d=(Dado)it.next();
                                    if (d.getTirada()>dadoMayorAtaque) {
                                        dadoMayorAtaque=d.getTirada();
                                        posA=i;
                                    }
                                    i++;
                                }
                                // eliminamos el dado
                                dadosAtaque.remove(posA);
                                // AHORA BUSCAMOS EL MAYOR DE DEFENSA
                                int dadoMayorDefensa = 0;
                                int posD=0; // posicion en la lista del dado mayor de defensa, para despues borrar
                                i=0;
                                it = dadosDefensa.iterator();
                                while (it.hasNext()) {
                                    Dado d=(Dado)it.next();
                                    if (d.getTirada()>dadoMayorDefensa) {
                                        dadoMayorDefensa=d.getTirada();
                                        posD=i;
                                    }
                                    i++;
                                }
                                // eliminamos el dado
                                dadosDefensa.remove(posD);

                                // COMPARAR RESULTADOS
                                if (dadoMayorAtaque>=dadoMayorDefensa) {
                                    System.out.println ("Ha ganado el atacante: "+dadoMayorAtaque+" >= "+dadoMayorDefensa);
                                    tDefensor.bajaEjercitos();
                                    if (tDefensor.getEjercitos()==0) {
                                        System.out.println ("Has ganado el pais");
                                        this.cambiarPosesionPais (jug,tAtacante, tDefensor);
                                    }
                                }
                                else {
                                    System.out.println ("Ha ganado el defensor: "+dadoMayorAtaque+" < "+dadoMayorDefensa);
                                    tAtacante.bajaEjercitos();
                                }
                        } // fin del while comparando dados                        
                    } // fin opcion continuar
                    else {
                        System.out.println ("Se ha retirado.");
                    }
                } // fin del while
                if (opcionContinuar==1 && !jug.PuedeAtacarA(origen, destino))
                    System.out.println("El ataque ha finalizado");                                
                } 
                else {
                    System.out.println ("No puedes atacar al pais seleccionado");
                }
            }
            else {
                System.out.println("No puedes atacar con el pais seleccionado");
            }                
        } else {
            System.out.println ("No puede atacar, hasta que no coloque los ejercitos.");
        }
    }
    
    public void moverEjercito (Jugador jug) {
    if (this.tropascolocadas) {
            System.out.println ("OPCION MOVER EJERCITO");
        } else {
            System.out.println ("No puede atacar, hasta que no coloque los ejercitos.");
        }
    }
    
    public void verCartas (Jugador jug) {
        System.out.println ("OPCION VER CARTAS");
    }
    
    public void finalizarTurno (Jugador jug) {
        this.turno++;
        if (this.turno>this.numeroJugadores) this.turno=1;
        this.tropascolocadas=false;
    }
    
    public void menu () {
        System.out.println ("Menu no disponible");
    }

    // cambiamos un pais de posesion. Ademas movemos un ejercito del origen al destino
    public void cambiarPosesionPais(Jugador jug, Territorio tOrigen, Territorio tDestino) {
        // primero buscar de quien es el pais destino
        Iterator it = mJugador.iterator();
        while (it.hasNext()) {
            Jugador j=(Jugador)it.next();
            j.eliminarPosesionTerritorio (tDestino);
        }
        tDestino.setEjercitos(1);
        tOrigen.bajaEjercitos();
        jug.poseeTerritorio(tDestino);
    }    
}

