import java.util.ArrayList;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
import java.util.Iterator;
// #[regen=yes,id=DCE.00D78959-8865-42F6-BB95-956A8F57D749]
import java.util.Random;
// </editor-fold> 
public class Territorio {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.1E3F4BEA-9A76-D9FC-5E82-E9EE1F05C7BE]
    // </editor-fold> 
    private int ejercitos;
    private int id;
    private String nombre;
   
    
    private ArrayList<Territorio> vecinos = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3023ECD1-DB86-A600-CE4D-EFA607D2653D]
    // </editor-fold> 
    public Territorio () {
    }
    
    public Territorio (int i, String nom) {
        this.id=i;
        this.nombre=nom;
        Random rnd = new Random ();                
        this.ejercitos = (int)(rnd.nextInt(10)+1);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E7D30B03-3CE6-2BAB-A477-8DB7226DE811]
    // </editor-fold> 
    public int getEjercitos () {
        return ejercitos;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DFB1DF19-99BA-095B-3043-E227FA72A413]
    // </editor-fold> 
    public void setEjercitos (int val) {
        this.ejercitos = val;
    }
    
    // restamos una unidad al ejercito
    public void bajaEjercitos () {
        this.ejercitos--;
    }
    
    public void addVecino (Territorio t) {
        this.vecinos.add(t);
    }
    
  
    public String getNombre () {
        return this.nombre;
    }
    
    public int getId () {
        return this.id;
    }
    
    public ArrayList<Territorio> getVecinos () {
        return vecinos;
    }

    public Territorio getVecino(int id) {
        Iterator it = this.vecinos.iterator();
        while (it.hasNext()) {
            Territorio t=(Territorio)it.next();
            if (t.getId()==id) return t;
        }               
        return null;
    }
    
}

