import java.util.ArrayList;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
import java.util.Iterator;
// #[regen=yes,id=DCE.937A1160-FBD1-01C2-938E-BBB75D749FE4]
import java.util.Random;
// </editor-fold> 
public class Jugador {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2BDBE18C-65CC-7A7D-A712-DA86E4232A50]
    // </editor-fold> 
    private int ejercitosdisponibles;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.785FCEFA-1820-C3CA-EBFD-9E6AE6A3316F]
    // </editor-fold> 
    private ArrayList<Territorio> mTerritorio = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.826FCBCA-CE4C-54F2-21C5-A89FA5644DE4]
    // </editor-fold> 
    private ArrayList<CartaTerritorio> mCartaTerritorio;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C2A79911-FA7A-DDBD-81E9-0513D654C4DA]
    // </editor-fold> 
    private CartaMision mCartaMision;
    
    private int numero;
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8C94C24B-3E92-6899-3286-470B16251732]
    // </editor-fold> 
    public Jugador () {
        
    }
    
    public Jugador (int num, String nom) {
        this.numero=num;
        this.nombre=nom;
        this.ejercitosdisponibles=3;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.AC7C5A5C-675D-1B23-5ADB-F740116E7412]
    // </editor-fold> 
    public CartaMision getCartaMision () {
        return null;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E7CC82A2-5D63-F8BD-3607-DC1246182629]
    // </editor-fold> 
    public void setCartaMision (CartaMision val) {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8DB1DBA1-DA12-EF3B-C3E4-FFB47D903046]
    // </editor-fold> 
    public ArrayList<CartaTerritorio> getCartaTerritorio () {
        return null;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.49EFB3A5-6D08-5BDE-CF4A-55C9240E7F85]
    // </editor-fold> 
    public void setCartaTerritorio (ArrayList<CartaTerritorio> val) {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.3EBE4474-52D7-80EA-29B9-152FFDF1D0EA]
    // </editor-fold> 
    public ArrayList<Territorio> getTerritorio () {
        return mTerritorio;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B1010932-A227-3BB4-AC58-4A307FAD51FF]
    // </editor-fold> 
    public void setTerritorio (ArrayList<Territorio> val) {
    }
    
    public String getNombre () {
        return this.nombre;
    }
    
    public int getNumero () {
        return this.numero;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F3B91DA2-2DDB-CFBD-E5BF-CDB5D215B3B7]
    // </editor-fold> 
    public int getEjercitosdisponibles () {
        return ejercitosdisponibles;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7FE0D208-AD85-8B30-597A-082E4787C9BA]
    // </editor-fold> 
    public void setEjercitosdisponibles (int val) {
        this.ejercitosdisponibles = val;
    }
    
    public void addEjercitosdisponibles (int val) {
        this.ejercitosdisponibles+=val;
    }
    
    public void poseeTerritorio (Territorio t) {
        mTerritorio.add(t);
    }

    // devuelve un bojeto Territorio que tenga el id introducido
    public Territorio getTerritorioPoseido (int id) {
        Iterator it = this.mTerritorio.iterator();
        while (it.hasNext()) {
            Territorio t=(Territorio)it.next();
            if (t.getId()==id) return t;
        }
        return null;
    }
    public boolean puedeAtacar(int id) {
        Territorio pais=this.getTerritorioPoseido(id);
        if (pais!=null && pais.getEjercitos()>1) return true;
        return false;
    }

    public boolean PuedeAtacarA(int idorigen, int iddestino) {
        // comprobamos que el pais de origen puede atacar
        if (!this.puedeAtacar(idorigen)) return false;
        // comprobamos el pais destino puede ser atacado
        if (this.getTerritorioPoseido(idorigen).getVecino(iddestino)==null) return false;
        // comprobamos que el pais destino no sea tambien del mismo jugador
        if (this.getTerritorioPoseido(iddestino)!=null) return false;
        // comprobamos que tenga al menos un ejercito
        if (this.getTerritorioPoseido(idorigen).getVecino(iddestino).getEjercitos()==0) return false;
               
        return true;
    }

    public void eliminarPosesionTerritorio(Territorio tDestino) {
        Iterator it = mTerritorio.iterator();
        this.mTerritorio.remove(tDestino);
    }
               

}

